# My menus.		

menu -n File -p fileMenuProc {
	"/Nnew"
	"/Oopen"
	{menu -n recent {}}
	"<S/Wclose"
	"<S<I<O/WcloseAll"
	"(-"
	"<S/Ssave"
	"<S<I<O/SsaveAll"
	"<SsaveACopyAs"
	"<SsaveAs"
	"revert"
	"(-"
	"/Yshell"
	"(-"
	"pageSetup"
	{menu -n print {}}
	"(-"
	"/Qquit"
}


proc fileMenuProc {menu item} {
	if {$item == "open"} {
		findFile
	} elseif {$item == "close"} {
		killWindow
	} else {
		$item
	}
}


menu -n Edit {
	"/Zundo"
	"/Z<I<Oredo"
	"/Lload"
	"(-"
	"/X<Scut"
	"/X<S<I<Ocut&Append"
	"/C<Scopy"
	"/C<S<I<Ocopy&Append"
	"/V<Spaste"
	"/V<S<I<OpastePop"
	"(-"
	"/`<Stwiddle"
	"/`<S<I<OtwiddleWords"
	"yank"
	"/A<SselectAll"
	"/A<S<I<OselectParagraph"
	"clear"
	"(-"
	{/[<SshiftLeft}
	{/[<S<I<OshiftLeftSpace}
	{/]<SshiftRight}
	{/]<S<I<OshiftRightSpace}
	"/Bbalance"
	"(-"
	"viewSavedSetting"
	"removeSavedSetting"
	"editPrefs.tcl"
}

menu -n Search {
	"/F<Sfind"
	"/F<S<I<OsearchStart"
	"/G<SfindAgain"
	"/G<S<I<OfindAgainBackward"
	"/H<I<OfindInNextFile"
	"(-"
	"/E<SenterSearchString"
	"/E<S<I<OenterReplaceString"
	"(-"
	"/Rreplace"
	"/Hreplace&FindAgain"
	"<S/R<O<IreplaceAll"
	"<S/R<O<I<BreplaceInFileset"
	"(-"
	"/=markHilite"
	"(-"
	{menu -n namedMarks -p namedMarkProc {
		"/K<O<Sset"
		"/K<O<B<SmarkFile"
		"/K<I<Ogoto"
		"remove"
		"(-"
		"sort"
		"sortByPosition"}}
	{menu -n unnamedMark -p unnamedMarkproc {
		"set"
		"exchangePointAndMark"}}
	{menu -n markStack -p markMenuProc { "/,<Bpush" "/.<Bpop"}}
	{menu -n registers { pointToRegister jumpToRegister }}
}

proc namedMarkProc {menu item} {
	switch $item {
		"markFile"			{markFile; message "File marked."}
		"set" 				{setNamedMark}
		"goto"				{gotoFileMark}
		"remove"			{removeNamedMark}
		"sort"				{sortMarksFile}
		"sortByPosition"	{orderMarks}
	}
}

proc unnamedMarkproc {menu item} {
	switch $item {
		"set" 					{setMark}
		"exchangePointAndMark"	{exchangePointAndMark}
		"hilite"				{markHilite}
	}
}
	
proc markMenuProc {menu item} {
	switch $item {
		"push" 	{pushMark}
		"pop"	{popMark}
	}
}
		
proc installProc {menu item} {
	switch $item {
		"Electric Alias" 	{loadElectricAlias}
		"LaTeX 2.09"		{loadLaTeX}
		"LaTeX2e"			{loadLaTeX}
		"MacPerl"			{loadMacPerl}
	}
}


menu -n "Utils" {
		{menu -n fileUtils {
			"insertPathName"
			"insertFile"
			"fileRemove"
			"fileInfo"
			"wordCount"}}
		{menu -m -n compare -p compareProc {
			"Windows"
			"Files"
			"Directories"}}
		{menu -n asciiEtc {
			"quoteChar"
			"(-"
			"keyCode"
			"keyAscii"
			"getAscii"
			"insertAscii"}}
		"(-"
		"evaluate"
		{menu -n KbdMacros {
			"/qstartKeyboardMacro"
			"/rendKeyboardMacro"
			"/sexecuteKeyboardMacro"
			"dumpMacro"}}
		"(-"
		"sortLines"
		"/L<I<OspellcheckWindow"
		"sendUrl"
		"(-"
		"/M<I<OmatchingLines"
		"gotoMatch"
		"/inextMatch"
		"(-"
		{menu -n NamedClipboards -p namedClipMenuProc {"copy" "cut" "paste"}}
		{menu -m -n install -p installProc {
			"Electric Alias"
			"MacPerl"
			"(-"
			"LaTeX2e"
			"LaTeX 2.09"
		}}
		listFunctions
}


proc compareProc {menu item} {
	catch {compare$item} msg
	message $msg
}

proc namedClipMenuProc {menu item} {
	switch $item {
		"copy" 		"copyNamedClipboard"
		"cut" 		"cutNamedClipboard"
		"paste" 	"pasteNamedClipboard"
	}
}

		
menu	-n Mode {
		{menu -s -n flags -p editFlag {}}
		{menu -s -n vars -p editVar {}}
		"(-"
		"/jcmdDoubleClick"
		"/kdescribeBinding"
		"listBindings"
		{menu -n emacs {}}
		{menu -n appPaths {}}
		"(-"
		"/lsetFontsTabs"
		"(-"
		{menu -m -n switchTo -p switchProc {}}
		"toolserverShell"
}

# ==== NOTE:  rectMarkHilite, onespace, centerRedraw, doTab
menu	-n Convert {
		"/I<SfillParagraph"
		"/I<S<O<IwrapParagraph"
		"/I<S<O<BsentenceParagraph"
		"/U<S<OfillRegion"
		"/U<S<I<OwrapRegion"
		"<E<SparagraphToLine"
		"<SlineToParagraph"
		"(-"
		"zapInvisibles"
		"<SspacesToTabs"
		"<StabsToSpaces"
		"(-"
		{menu -n Strings {
			"<SremovePrefix"
			"<SinsertPrefix"
			"<S<EremoveSuffix"
			"<SinsertSuffix"
			"setPrefix"
			"setSuffix"
			}}
		"/D<ScommentLine"
		"/D<S<I<OuncommentLine"
		"<SuncommentBox"
		"<ScommentBox"
		"<S<EindentRegion"
		"<SindentLine"
		"(-"
		"<SupcaseRegion"
		"<SdowncaseRegion"
}

# Real Kludge
proc helpMenuProc {menu item} {
	global HOME helpMenu
	
	if {$menu == $helpMenu} {
		edit -r $HOME:Help:$item
	} else {
		edit -r $HOME:Help:$menu:$item
	}
# 	if {$item == "Manual"} {
# 		global winModes
# 		
# 		set nm [lindex [winNames -f] 0]
# 		set winModes($nm) Help
# 		changeMode Help
# 	}
}

proc strip {arg} {
	if {[regsub -all {\\([][\{\}])} $arg {\1} v]} {return $v}
	return $arg
}

set men { "Manual" "Alpha Commands" "Tcl Commands" "(-" "Readme" "Changes" "ToDo" "(-" }

foreach f [lsort -ignore [glob "$HOME:Help:*"]] {
	set f [file tail $f]
	if {($f != "Manual") && ($f != "Readme") && ($f != "Changes") && ($f != "ToDo") && ($f != "Alpha Commands") && ($f != "Tcl Commands")} {
		lappend men $f
	}
}
menu -n $helpMenu -s -m -p helpMenuProc $men
unset men


proc escapeSpaces {str} {
	regsub -all { } $str {\ } str2
	return $str2
}


proc buildSwitches {} {
	global switchApps
	
	menu -m -n switchTo -p switchProc {"<O<I/NNow" "Add" "Remove" "(-"}

	if {[info exists switchApps]} {
		foreach app $switchApps {
			lappend names [file tail $app]
		}
		foreach name [lsort -ignore $names] {
			addMenuItem -m -l "blah" switchTo $name
		}
	}
}


proc switchProc {menu name} {
	global switchTo switchApps

	if {$name == "Add"} {
		set fname [getfile "Pick an app:"]
		lappend switchApps $fname
		addDef switchApps $switchApps
		buildSwitches
	} elseif {$name == "Remove"} {
		foreach app $switchApps {
			lappend apps [file tail $app]
		}
		set name [listpick -p "Remove which app?" $apps]
		if {[set ind [lsearch $switchApps "*$name"]] >= 0} {
			set switchApps [lreplace $switchApps $ind $ind]
			addDef switchApps $switchApps
			buildSwitches
		}
	} elseif {$name == "Now"} {
		switchApp
	} else {
		if {[set ind [lsearch $switchApps "*$name"]] >= 0} {
			if {[catch {switchTo $name}]} {
				launch -f [lindex $switchApps $ind]
			}
		}
	}
}
		

proc winTileProc {menu item} {
	win$item
}

menu -n $winMenu -p menuWin {
		{menu -n arrange -p winTileProc {
			"/Jvertically^1"
			"/J<O<Ihorizontally^2"
			"tiled^3"
			"overlay^4"
			"(-"
			{menu -n other {
				{bufferOtherWindow}
				{chooseAWindow}
				{chooseWindowStatus}
				{iconify}
				{killWindowStatus}
				{nextWin}
				{nextWindow}
				{otherThing}
				{prevWindow}
				{shrinkFull}
				{shrinkHigh}
				{shrinkLeft}
				{shrinkLow}
				{shrinkRight}
				{singlePage}
				{swapWithNext}
				{threeQuarters}
				{winhorizontally}
				{winoverlay}
				{wintiled}
				{winvertically}
				{zoom}
			}}}}
		"(-"
		"//<Szoom"
		"//<S<I<OsinglePage"
		"/Y<O<Iiconify"
		"splitWindow"
		"/otoggleScrollbar"
		"(-"
		"<SprevWindow"
		"<SnextWindow"
		"swapWithNext"
		"<S/;chooseAWindow"
		"(-"
}

# We may be reloading, so add whatever windows we have
if {[info exists winNameToNum]} {
	set nms [array names winNameToNum]
	foreach name $nms {
		regexp {[^:]*$} $name item
		set num $winNameToNum($name)
		if {$num < 10} 	{
			addMenuItem -m $winMenu /$num$item
		} else {
			addMenuItem -m $winMenu $item
		}
	}
}

insertMenu "File"
insertMenu "Edit"
insertMenu "Search"
insertMenu "Utils"
insertMenu "Mode"
enableMenuItem NamedClipboards paste off
insertMenu "Convert"
menu -n $fsetMenuName {}; 
insertMenu $winMenu

catch {insertMenu $helpMenu}


menu -n $terrMenu {}

menu -n $toolserverMenu {}

