
menu -n "137" -p colorMenu {
	black
	blue
	cyan
	green
	magenta
	red
	white
	yellow

	bold
	condense
	extend
	italic
	normal
	outline
	shadow
	underline

	"(-"
	"/H<UmarkAsHyper"
	"redWord"
	"underlineWord"
	"removeColorEscapes"
}
	
insertMenu "137"

proc redWord {} {
	insertColorEscape [getPos] 5
	insertColorEscape [selEnd] 0
}
proc underlineWord {} {
	insertColorEscape [getPos] 15
	insertColorEscape [selEnd] 12
}
proc blueWord {} {
	insertColorEscape [getPos] 1
	insertColorEscape [selEnd] 0
}

proc colorMenu {menu item} {

	switch $item {
		black {colorSelect 0 0}
		blue {colorSelect 1 0}
		cyan {colorSelect 2 0}
		green {colorSelect 3 0}
		magenta {colorSelect 4 0}
		red {colorSelect 5 0}
		white {colorSelect 6 0}
		yellow {colorSelect 7 0}
	
		bold {colorSelect 8 12}
		condense {colorSelect 9 12}
		extend {colorSelect 10 12}
		italic {colorSelect 11 12}
		normal {colorSelect 12 12}
		outline {colorSelect 13 12}
		shadow {colorSelect 14 12}
		underline {colorSelect 15 12}	

		markAsHyper {markAsHyper}
		redWord {redWord}
		underlineWord {underlineWord}
		removeColorEscapes {removeColorEscapes}
	}
}

proc colorSelect {ind ind2} {
	set from [getPos]
	set to [selEnd]
	
	insertColorEscape $from $ind
	insertColorEscape $to $ind2
}

	

#===============================================================================


proc markManual {} {
	set pos 0
	while {[string length [set inds [search -f 1 -r 1 {^	  	} $pos]]]} {
		set pos1 [lindex $inds 1]
		set label [getText $pos1 [expr [nextLineStart $pos1] - 1]]
		set pos2 [lineStart $pos1]
		setNamedMark $label $pos2 $pos2 $pos2
		set pos [expr [nextLineStart $pos1]]
	}
}

proc colorManualMarks {} {
	goto 0
	hiliteWord
	endLineSelect
	set from [getPos]
	set to [selEnd]
	insertColorEscape $from 5
	insertColorEscape $from 15
	insertColorEscape $to 12
	insertColorEscape $to 0

	foreach mk [getNamedMarks] {
		set name [lindex $mk 0]
		set disp [lindex $mk 2]
		set pos [lindex $mk 3]
		set end [lindex $mk 4]
		
		goto $disp
		hiliteWord
		endLineSelect
		set from [getPos]
		set to [selEnd]
		
		insertColorEscape $from 5
		insertColorEscape $from 15
		insertColorEscape $to 12
		insertColorEscape $to 0
	}
}

#===============================================================================

proc markAlphaCommands {} {
	set pos 0
	while {[string length [set inds [search -f 1 -r 1 {^ } $pos]]]} {
		set pos1 [lindex $inds 1]
		goto $pos1
		hiliteWord
		set label [getSelect]
		set from [getPos]
		set to [selEnd]
		setNamedMark $label $pos1 $from $to
		insertColorEscape $from 1
		insertColorEscape $to 0
		set pos [expr [nextLineStart $pos1]]
	}
}

#===============================================================================

proc markChanges {} {
	set pos 0
	while {[string length [set inds [search -f 1 -r 1 {^= } $pos]]]} {
		set pos1 [lindex $inds 1]
		goto $pos1
		endLineSelect
		redWord
		set pos [expr [nextLineStart $pos1]]
	}
}

#===============================================================================

set lastHyper {} 

proc markAsHyper {} {
	global lastHyper
	
	set from [getPos]
	set to [selEnd]
	if {$from == $to} {
		beep
		return
	}
	set lastHyper [prompt "Hyper-text?" $lastHyper]
	insertColorEscape $from 3
	insertColorEscape $from 15 $lastHyper
	insertColorEscape $to 12
	insertColorEscape $to 0
}

proc colorDummy {} {}
